Vamp::HostExt::PluginChannelAdapter Class Reference

`#include <vamp-hostsdk/PluginChannelAdapter.h>`

Inheritance diagram for Vamp::HostExt::PluginChannelAdapter:
[legend]

## Public Types

enum | InputDomain { TimeDomain, FrequencyDomain }
typedef std::vector< OutputDescriptor > | OutputList
typedef std::vector< Feature > | FeatureList
typedef std::map< int, FeatureList > | FeatureSet
typedef std::vector< ParameterDescriptor > | ParameterList
typedef std::vector< std::string > | ProgramList

## Public Member Functions

| PluginChannelAdapter (Plugin *plugin)
| Construct a PluginChannelAdapter wrapping the given plugin. More...
virtual | ~PluginChannelAdapter ()
bool | initialise (size_t channels, size_t stepSize, size_t blockSize)
| Initialise a plugin to prepare it for use with the given number of input channels, step size (window increment, in sample frames) and block size (window size, in sample frames). More...
FeatureSet | process (const float *const *inputBuffers, RealTime timestamp)
| Process a single block of input data. More...
FeatureSet | processInterleaved (const float *inputBuffer, RealTime timestamp)
| Call process(), providing interleaved audio data with the number of channels passed to initialise(). More...
void | reset ()
| Reset the plugin after use, to prepare it for another clean run. More...
InputDomain | getInputDomain () const
| Get the plugin's required input domain. More...
unsigned int | getVampApiVersion () const
| Get the Vamp API compatibility level of the plugin. More...
std::string | getIdentifier () const
| Get the computer-usable name of the plugin. More...
std::string | getName () const
| Get a human-readable name or title of the plugin. More...
std::string | getDescription () const
| Get a human-readable description for the plugin, typically a line of text that may optionally be displayed in addition to the plugin's "name". More...
std::string | getMaker () const
| Get the name of the author or vendor of the plugin in human-readable form. More...
int | getPluginVersion () const
| Get the version number of the plugin. More...
std::string | getCopyright () const
| Get the copyright statement or licensing summary for the plugin. More...
ParameterList | getParameterDescriptors () const
| Get the controllable parameters of this plugin. More...
float | getParameter (std::string) const
| Get the value of a named parameter. More...
void | setParameter (std::string, float)
| Set a named parameter. More...
ProgramList | getPrograms () const
| Get the program settings available in this plugin. More...
std::string | getCurrentProgram () const
| Get the current program. More...
void | selectProgram (std::string)
| Select a program. More...
size_t | getPreferredStepSize () const
| Get the preferred step size (window increment – the distance in sample frames between the start frames of consecutive blocks passed to the process() function) for the plugin. More...
size_t | getPreferredBlockSize () const
| Get the preferred block size (window size – the number of sample frames passed in each block to the process() function). More...
size_t | getMinChannelCount () const
| Get the minimum supported number of input channels. More...
size_t | getMaxChannelCount () const
| Get the maximum supported number of input channels. More...
OutputList | getOutputDescriptors () const
| Get the outputs of this plugin. More...
FeatureSet | getRemainingFeatures ()
| After all blocks have been processed, calculate and return any remaining features derived from the complete input. More...
template<typename WrapperType >
WrapperType * | getWrapper ()
| Return a pointer to the plugin wrapper of type WrapperType surrounding this wrapper's plugin, if present. More...
void | disownPlugin ()
| Disown the wrapped plugin, so that we no longer delete it on our own destruction. More...
virtual std::string | getType () const
| Used to distinguish between Vamp::Plugin and other potential sibling subclasses of PluginBase. More...
float | getInputSampleRate () const
| Retrieve the input sample rate set on construction. More...

## Protected Attributes

Impl * | m_impl
Plugin * | m_plugin
bool | m_pluginIsOwned
float | m_inputSampleRate

## Detailed Description

PluginChannelAdapter is a Vamp plugin adapter that implements a policy for management of plugins that expect a different number of input channels from the number actually available in the source audio data.

A host using PluginChannelAdapter may ignore the getMinChannelCount and getMaxChannelCount reported by the plugin, and still expect the plugin to run.

PluginChannelAdapter implements the following policy:

- If the plugin supports the provided number of channels directly, PluginChannelAdapter will just run the plugin as normal.
- If the plugin only supports exactly one channel but more than one channel is provided, PluginChannelAdapter will use the mean of the channels. This ensures that the resulting values remain within the same magnitude range as expected for mono data.
- If the plugin requires more than one channel but exactly one is provided, the provided channel will be duplicated across all the plugin input channels.

If none of the above apply:

- If the plugin requires more channels than are provided, the minimum acceptable number of channels will be produced by adding empty (zero valued) channels to those provided.
- If the plugin requires fewer channels than are provided, the maximum acceptable number of channels will be produced by discarding the excess channels.

Hosts requiring a different channel policy from the above will need to implement it themselves, instead of using PluginChannelAdapter.

Note that PluginChannelAdapter does not override the minimum and maximum channel counts returned by the wrapped plugin. The host will need to be aware that it is using a PluginChannelAdapter, and be prepared to ignore these counts as necessary. (This contrasts with the approach used in PluginInputDomainAdapter, which aims to make the host completely unaware of which underlying input domain is in fact in use.)

(The rationale for this is that a host may wish to use the PluginChannelAdapter but still discriminate in some way on the basis of the number of channels actually supported. For example, a simple stereo audio host may prefer to reject plugins that require more than two channels on the grounds that doesn't actually understand what they are for, rather than allow the channel adapter to make a potentially meaningless channel conversion for them.)

In every respect other than its management of channels, the PluginChannelAdapter behaves identically to the plugin that it wraps. The wrapped plugin will be deleted when the wrapper is deleted. If you wish to prevent this, call disownPlugin().

Note
  This class was introduced in version 1.1 of the Vamp plugin SDK.

Definition at line 112 of file PluginChannelAdapter.h.

## Member Typedef Documentation

## OutputList

typedef std::vector<OutputDescriptor> Vamp::Plugin::OutputList

inherited

Definition at line 335 of file vamp-sdk/Plugin.h.

## FeatureList

typedef std::vector<Feature> Vamp::Plugin::FeatureList

inherited

Definition at line 393 of file vamp-sdk/Plugin.h.

## FeatureSet

typedef std::map<int, FeatureList> Vamp::Plugin::FeatureSet

inherited

Definition at line 395 of file vamp-sdk/Plugin.h.

## ParameterList

typedef std::vector<ParameterDescriptor> Vamp::PluginBase::ParameterList

inherited

Definition at line 203 of file vamp-sdk/PluginBase.h.

## ProgramList

typedef std::vector<std::string> Vamp::PluginBase::ProgramList

inherited

Definition at line 225 of file vamp-sdk/PluginBase.h.

## Member Enumeration Documentation

## InputDomain

enum Vamp::Plugin::InputDomain

inherited

Enumerator
TimeDomain |
FrequencyDomain |

Definition at line 152 of file vamp-sdk/Plugin.h.

## Constructor & Destructor Documentation

## PluginChannelAdapter()

Vamp::HostExt::PluginChannelAdapter::PluginChannelAdapter | ( | Plugin * | plugin | ) |

Construct a PluginChannelAdapter wrapping the given plugin.

The adapter takes ownership of the plugin, which will be deleted when the adapter is deleted. If you wish to prevent this, call disownPlugin().

## ~PluginChannelAdapter()

virtual Vamp::HostExt::PluginChannelAdapter::~PluginChannelAdapter | ( |  | ) |

virtual

## Member Function Documentation

## initialise()

bool Vamp::HostExt::PluginChannelAdapter::initialise | ( | size_t | inputChannels,
|  | size_t | stepSize,
|  | size_t | blockSize
| ) |  |

virtual

Initialise a plugin to prepare it for use with the given number of input channels, step size (window increment, in sample frames) and block size (window size, in sample frames).

The input sample rate should have been already specified at construction time.

Return true for successful initialisation, false if the number of input channels, step size and/or block size cannot be supported.

Implements Vamp::Plugin.

## process()

FeatureSet Vamp::HostExt::PluginChannelAdapter::process | ( | const float *const * | inputBuffers,
|  | RealTime | timestamp
| ) |  |

virtual

Process a single block of input data.

If the plugin's inputDomain is TimeDomain, inputBuffers will point to one array of floats per input channel, and each of these arrays will contain blockSize consecutive audio samples (the host will zero-pad as necessary). The timestamp in this case will be the real time in seconds of the start of the supplied block of samples.

If the plugin's inputDomain is FrequencyDomain, inputBuffers will point to one array of floats per input channel, and each of these arrays will contain blockSize/2+1 consecutive pairs of real and imaginary component floats corresponding to bins 0..(blockSize/2) of the FFT output. That is, bin 0 (the first pair of floats) contains the DC output, up to bin blockSize/2 which contains the Nyquist-frequency output. There will therefore be blockSize+2 floats per channel in total. The timestamp will be the real time in seconds of the centre of the FFT input window (i.e. the very first block passed to process might contain the FFT of half a block of zero samples and the first half-block of the actual data, with a timestamp of zero).

Return any features that have become available after this process call. (These do not necessarily have to fall within the process block, except for OneSamplePerStep outputs.)

Implements Vamp::Plugin.

## processInterleaved()

FeatureSet Vamp::HostExt::PluginChannelAdapter::processInterleaved | ( | const float * | inputBuffer,
|  | RealTime | timestamp
| ) |  |

Call process(), providing interleaved audio data with the number of channels passed to initialise().

The adapter will de-interleave into temporary buffers as appropriate before calling process().

Note
  This function was introduced in version 1.4 of the Vamp plugin SDK.

## reset()

void Vamp::HostExt::PluginWrapper::reset | ( |  | ) |

virtual inherited

Reset the plugin after use, to prepare it for another clean run.

Not called for the first initialisation (i.e. initialise must also do a reset).

Implements Vamp::Plugin.

## getInputDomain()

InputDomain Vamp::HostExt::PluginWrapper::getInputDomain | ( |  | ) | const

virtual inherited

Get the plugin's required input domain.

If this is TimeDomain, the samples provided to the process() function (below) will be in the time domain, as for a traditional audio processing plugin.

If this is FrequencyDomain, the host will carry out a windowed FFT of size equal to the negotiated block size on the data before passing the frequency bin data in to process(). The input data for the FFT will be rotated so as to place the origin in the centre of the block. The plugin does not get to choose the window type – the host will either let the user do so, or will use a Hanning window.

Implements Vamp::Plugin.

## getVampApiVersion()

unsigned int Vamp::HostExt::PluginWrapper::getVampApiVersion | ( |  | ) | const

virtual inherited

Get the Vamp API compatibility level of the plugin.

Reimplemented from Vamp::PluginBase.

## getIdentifier()

std::string Vamp::HostExt::PluginWrapper::getIdentifier | ( |  | ) | const

virtual inherited

Get the computer-usable name of the plugin.

This should be reasonably short and contain no whitespace or punctuation characters. It may only contain the characters [a-zA-Z0-9_-]. This is the authoritative way for a program to identify a plugin within a given library.

This text may be visible to the user, but it should not be the main text used to identify a plugin to the user (that will be the name, below).

Example: "zero_crossings"

Implements Vamp::PluginBase.

## getName()

std::string Vamp::HostExt::PluginWrapper::getName | ( |  | ) | const

virtual inherited

Get a human-readable name or title of the plugin.

This should be brief and self-contained, as it may be used to identify the plugin to the user in isolation (i.e. without also showing the plugin's "identifier").

Example: "Zero Crossings"

Implements Vamp::PluginBase.

## getDescription()

std::string Vamp::HostExt::PluginWrapper::getDescription | ( |  | ) | const

virtual inherited

Get a human-readable description for the plugin, typically a line of text that may optionally be displayed in addition to the plugin's "name".

May be empty if the name has said it all already.

Example: "Detect and count zero crossing points"

Implements Vamp::PluginBase.

## getMaker()

std::string Vamp::HostExt::PluginWrapper::getMaker | ( |  | ) | const

virtual inherited

Get the name of the author or vendor of the plugin in human-readable form.

This should be a short identifying text, as it may be used to label plugins from the same source in a menu or similar.

Implements Vamp::PluginBase.

## getPluginVersion()

int Vamp::HostExt::PluginWrapper::getPluginVersion | ( |  | ) | const

virtual inherited

Get the version number of the plugin.

Implements Vamp::PluginBase.

## getCopyright()

std::string Vamp::HostExt::PluginWrapper::getCopyright | ( |  | ) | const

virtual inherited

Get the copyright statement or licensing summary for the plugin.

This can be an informative text, without the same presentation constraints as mentioned for getMaker above.

Implements Vamp::PluginBase.

## getParameterDescriptors()

ParameterList Vamp::HostExt::PluginWrapper::getParameterDescriptors | ( |  | ) | const

virtual inherited

Get the controllable parameters of this plugin.

Reimplemented from Vamp::PluginBase.

## getParameter()

float Vamp::HostExt::PluginWrapper::getParameter | ( | std::string |  | ) | const

virtual inherited

Get the value of a named parameter.

The argument is the identifier field from that parameter's descriptor.

Reimplemented from Vamp::PluginBase.

## setParameter()

void Vamp::HostExt::PluginWrapper::setParameter | ( | std::string | ,
|  | float |
| ) |  |

virtual inherited

Set a named parameter.

The first argument is the identifier field from that parameter's descriptor.

Reimplemented from Vamp::PluginBase.

## getPrograms()

ProgramList Vamp::HostExt::PluginWrapper::getPrograms | ( |  | ) | const

virtual inherited

Get the program settings available in this plugin.

A program is a named shorthand for a set of parameter values; changing the program may cause the plugin to alter the values of its published parameters (and/or non-public internal processing parameters). The host should re-read the plugin's parameter values after setting a new program.

The programs must have unique names.

Reimplemented from Vamp::PluginBase.

## getCurrentProgram()

std::string Vamp::HostExt::PluginWrapper::getCurrentProgram | ( |  | ) | const

virtual inherited

Get the current program.

Reimplemented from Vamp::PluginBase.

## selectProgram()

void Vamp::HostExt::PluginWrapper::selectProgram | ( | std::string |  | ) |

virtual inherited

Select a program.

(If the given program name is not one of the available programs, do nothing.)

Reimplemented from Vamp::PluginBase.

## getPreferredStepSize()

size_t Vamp::HostExt::PluginWrapper::getPreferredStepSize | ( |  | ) | const

virtual inherited

Get the preferred step size (window increment – the distance in sample frames between the start frames of consecutive blocks passed to the process() function) for the plugin.

This should be called before initialise().

A plugin may return 0 if it has no particular interest in the step size. In this case, the host should make the step size equal to the block size if the plugin is accepting input in the time domain. If the plugin is accepting input in the frequency domain, the host may use any step size. The final step size will be set in the initialise() call.

Reimplemented from Vamp::Plugin.

## getPreferredBlockSize()

size_t Vamp::HostExt::PluginWrapper::getPreferredBlockSize | ( |  | ) | const

virtual inherited

Get the preferred block size (window size – the number of sample frames passed in each block to the process() function).

This should be called before initialise().

A plugin that can handle any block size may return 0. The final block size will be set in the initialise() call.

Reimplemented from Vamp::Plugin.

## getMinChannelCount()

size_t Vamp::HostExt::PluginWrapper::getMinChannelCount | ( |  | ) | const

virtual inherited

Get the minimum supported number of input channels.

Reimplemented from Vamp::Plugin.

## getMaxChannelCount()

size_t Vamp::HostExt::PluginWrapper::getMaxChannelCount | ( |  | ) | const

virtual inherited

Get the maximum supported number of input channels.

Reimplemented from Vamp::Plugin.

## getOutputDescriptors()

OutputList Vamp::HostExt::PluginWrapper::getOutputDescriptors | ( |  | ) | const

virtual inherited

Get the outputs of this plugin.

An output's index in this list is used as its numeric index when looking it up in the FeatureSet returned from the process() call.

Implements Vamp::Plugin.

## getRemainingFeatures()

FeatureSet Vamp::HostExt::PluginWrapper::getRemainingFeatures | ( |  | ) |

virtual inherited

After all blocks have been processed, calculate and return any remaining features derived from the complete input.

Implements Vamp::Plugin.

## getWrapper()

template<typename WrapperType >

WrapperType* Vamp::HostExt::PluginWrapper::getWrapper | ( |  | ) |

inline inherited

Return a pointer to the plugin wrapper of type WrapperType surrounding this wrapper's plugin, if present.

This is useful in situations where a plugin is wrapped by multiple different wrappers (one inside another) and the host wants to call some wrapper-specific function on one of the layers without having to care about the order in which they are wrapped. For example, the plugin returned by PluginLoader::loadPlugin may have more than one wrapper; if the host wanted to query or fine-tune some property of one of them, it would be hard to do so without knowing the order of the wrappers. This function therefore gives direct access to the wrapper of a particular type.

Definition at line 119 of file PluginWrapper.h.

References Vamp::HostExt::PluginWrapper::getWrapper().

Referenced by Vamp::HostExt::PluginWrapper::getWrapper(), and runPlugin().

## disownPlugin()

void Vamp::HostExt::PluginWrapper::disownPlugin | ( |  | ) |

inherited

Disown the wrapped plugin, so that we no longer delete it on our own destruction.

The identity of the wrapped plugin is unchanged, but this switches the expectation about ownership so that the caller is expected to handle the lifecycle of the wrapped plugin and to ensure that it outlasts this wrapper.

This is not the normal model, but could be useful in situations where a plugin is already managed using a smart pointer model before being adapted into this wrapper. Note that this can't be reversed - if you call this, you must subsequently take charge of the wrapped plugin yourself.

## getType()

virtual std::string Vamp::Plugin::getType | ( |  | ) | const

inline virtual inherited

Used to distinguish between Vamp::Plugin and other potential sibling subclasses of PluginBase.

Do not reimplement this function in your subclass.

Implements Vamp::PluginBase.

Definition at line 438 of file vamp-sdk/Plugin.h.

## getInputSampleRate()

float Vamp::Plugin::getInputSampleRate | ( |  | ) | const

inline inherited

Retrieve the input sample rate set on construction.

Definition at line 443 of file vamp-sdk/Plugin.h.

## Member Data Documentation

## m_impl

Impl* Vamp::HostExt::PluginChannelAdapter::m_impl

protected

Definition at line 140 of file PluginChannelAdapter.h.

## m_plugin

Plugin* Vamp::HostExt::PluginWrapper::m_plugin

protected inherited

Definition at line 144 of file PluginWrapper.h.

## m_pluginIsOwned

bool Vamp::HostExt::PluginWrapper::m_pluginIsOwned

protected inherited

Definition at line 145 of file PluginWrapper.h.

## m_inputSampleRate

float Vamp::Plugin::m_inputSampleRate

protected inherited

Definition at line 449 of file vamp-sdk/Plugin.h.

Referenced by FixedTempoEstimator::D::assembleFeatures(), FixedTempoEstimator::D::calculate(), FixedTempoEstimator::D::getOutputDescriptors(), ZeroCrossing::getOutputDescriptors(), PercussionOnsetDetector::getOutputDescriptors(), AmplitudeFollower::initialise(), FixedTempoEstimator::D::initialise(), FixedTempoEstimator::D::lag2tempo(), ZeroCrossing::process(), SpectralCentroid::process(), PercussionOnsetDetector::process(), and FixedTempoEstimator::D::tempo2lag().

The documentation for this class was generated from the following file:

- PluginChannelAdapter.h